project.About = function(dom_element, options)
{
    var page = options.page || null;

    if (page)
    {
        page = 'Page ' + page;
    }

    if (options.site === 'about')
    {
        project.track('About Red Bull TV', 'About', 'About Red Bull TV', page);
    }
    else if (options.site === 'imprint')
    {
        project.track('Imprint', 'About', 'Imprint', page);
    }

    this.initializeNavigation();
};

project.About.prototype = {

    initializeNavigation: function()
    {
        var that = this;

        this.key_controller = new gtv.jq.KeyController();

        var nav_key_mapping = {};

        nav_key_mapping[project.keycodes.KEY_UP] = function(selectedItem, newSelected)
        {
            newSelected = jQuery('.pager .js_item').first();
            if (newSelected.length === 0)
            {
                newSelected = jQuery('.subnav .js_item').first();
            }
            return new gtv.jq.Selection('selected', newSelected);
        };
        nav_key_mapping[project.keycodes.KEY_DOWN] = function(selectedItem, newSelected)
        {
            newSelected = jQuery('.subnav .js_item').first();
            return new gtv.jq.Selection('selected', newSelected);
        };

        var subnav_key_mapping = {};

        subnav_key_mapping[project.keycodes.KEY_DOWN] = function(selectedItem, newSelected)
        {
            newSelected = jQuery('.pager .js_item').first();
            if (newSelected.length === 0)
            {
                newSelected = jQuery('#nav .js_item').first();
            }
            return new gtv.jq.Selection('selected', newSelected);
        };

        this.nav_zone = project.getMenuBehaviourZone(nav_key_mapping);
        this.subnav_zone = project.getSubMenuBehaviourZone(subnav_key_mapping);
        this.pager_zone = project.getPagerBehaviourZone();

        this.key_controller.addBehaviorZone(this.nav_zone);
        this.key_controller.addBehaviorZone(this.subnav_zone);

        if (jQuery('.pager').length > 0)
        {
            this.key_controller.addBehaviorZone(this.pager_zone);
            this.key_controller.start(this.pager_zone, true);
        }
        else
        {
            this.key_controller.start(this.subnav_zone, true);
        }
    }
};

jQuery.extend(true, project.About.prototype, new project.Log());

JsBehaviourToolkit.registerHandler('about', project.About);
