project.CountDown = function(dom_element, options)
{
    this.DAY = 86400;
	this.HOUR = 3600;
	this.MINUTE = 60;
    
    this.dom_element = dom_element;
    
    var that = this;
    project.data_provider.callWebApi("live_event", function(data)
    {
        var server_time = Date.parse(data.server_time);
        var event_time = Date.parse(data.event_start_date);
        
        //event_time = Date.parse('2011/08/13 16:20:00');
        if (that.isSeriouslyNaN(server_time) || that.isSeriouslyNaN(event_time))
        {
            return;
        }
        
        server_time = new Date(server_time);
        event_time = new Date(event_time);
        
        that.seconds_til_event = Math.max(event_time.getTime() - server_time.getTime(), 0) / 1000;

        var text = project.string_toolkit.createCleanExcerpt(data.event_text, 25)
        that.dom_element.find('.js_description').html(text);
        
        that.dom_element.removeClass('hide');
        
        that.updateEvery(1000);
    });
};

project.CountDown.prototype = {
    
    isSeriouslyNaN: function(nan)
    {
        return (nan === '' || nan === null || isNaN(nan));
    },
    
    updateEvery: function(interval)
    {
        var delay = interval || 1000;
        var that = this;
        setInterval(function() {
            that.update();
        }, delay);
    },
    
    update: function()
    {
        this.seconds_til_event -= 1;
        var diff_in_seconds = this.seconds_til_event;
		var days = Math.floor(diff_in_seconds / this.DAY).toString();
		diff_in_seconds -= days * this.DAY;
		var hours = Math.floor(diff_in_seconds / this.HOUR).toString();
		diff_in_seconds -= hours * this.HOUR;
		var minutes = Math.floor(diff_in_seconds / this.MINUTE).toString();
		diff_in_seconds -= minutes * this.MINUTE;
		var seconds = Math.floor(diff_in_seconds).toString();
		
        this.dom_element.find('.js_countdown_days').text(this.pad(days));
        this.dom_element.find('.js_countdown_hours').text(this.pad(hours));
        this.dom_element.find('.js_countdown_minutes').text(this.pad(minutes));
        this.dom_element.find('.js_countdown_seconds').text(this.pad(seconds));
    },

    pad: function(num, len, pad)
    {
        var pad_str = pad || '0';
        var number = String(num);
        var length = parseInt(len, 10) || 2;
        while (number.length < length)
            number = pad_str + number;
        return number;
    }
};

JsBehaviourToolkit.registerHandler('count_down', project.CountDown);
