project.DataProvider = function(api_url, proxy_url, use_proxy)
{
    this.logging_prefix = 'DataProvider';
    
    this.api_url = api_url || 'http://authoring-dev.redbull.com/cs/Satellite?pagename=RBWebTV/RBWTVAPI&command=';

    this.proxy_url = proxy_url || '';

    this.use_proxy = use_proxy || false;
};

project.DataProvider.prototype = {
    callWebApi: function(command, callback, error_callback)
    {
        this.trace('callWebApi: ' + command);
        
        if (typeof(error_callback) !== 'function')
        {
            error_callback = function()
            {
                console.log('Default error handler called. Arguments are: ', arguments);
            };
        }

        var url = this.api_url + command;
        //this.trace('Calling WebApi' +(this.use_proxy?' (via proxy ' + this.proxy_path + ')':'') + ': ', url);

        if (this.use_proxy)
        {
            var that = this;
            var jqxhr = jQuery.getJSON(this.proxy_url, {
                url: url,
                cache: true
            }, function(a,b,c){
                callback(a);
            }).success(function() {
                //that.trace("second success");
            }).error(function(jqXHR, textStatus, errorThrown) {
                //that.trace(jqXHR.status + ' - ' + textStatus + ' - ' + errorThrown);
                error_callback(jqXHR, textStatus, errorThrown);
            }).complete(function() {
                //that.trace("complete");
            });
        }
        else
        {
            jQuery.ajax({
                'url': url + '&callback=?',
                'dataType': 'jsonp',
                'data': {},
                'jsonpCallback': this.sanitizeString('callback_for_' + command),
                'cache': true,
                'timeout': 30000,
                'success': callback,
                'error': error_callback
            });
        }
    },

    sanitizeString: function(str)
    {
        var sanitized = str.replace(/^\s+|\s+$/g, ''); // trim
        sanitized = sanitized.toLowerCase();
        sanitized = sanitized.replace(/[^a-z0-9 _-]/g, '') // remove everything special
            .replace(/\s+/g, '_') // collapse whitespaces to underlines
            .replace(/-+/g, '_'); // collapse multiple underlines

        return sanitized;
    }
};

jQuery.extend(true, project.DataProvider.prototype, new project.Log());

project.data_provider = new project.DataProvider(project.api_url, project.proxy_url, project.use_proxy);
