project.FeaturedShows = function(dom_element, options)
{
    this.dom_element = dom_element;
    
    this.shows_list_element = dom_element.find('ul');
    
    this.logging_prefix = 'FeaturedShows';

    this.trace(arguments);

    var that = this;

    project.data_provider.callWebApi("featured_shows&from=1&size=5", function(data)
    {
        if (!data.shows || !(data.shows.length > 0))
        {
            return;
        }

        var list_childs = that.shows_list_element.children('li');
        jQuery.each(data.shows, function(idx, show)
        {
            var li_ele = jQuery(list_childs[idx]);
            li_ele.find('.js_item').attr('href', 'episodes.html?origin=home&showid='+show.id);
            
            li_ele.find('.js_fs_image').attr({
                'src': show.thumbnail_url,
                'alt': show.title
            });

            if (idx == (data.shows.length - 1))
            {
                li_ele.addClass('last');
            }
        });

        that.dom_element.removeClass('hide');
    });
};

jQuery.extend(true, project.FeaturedShows.prototype, new project.Log());

JsBehaviourToolkit.registerHandler('featured_shows', project.FeaturedShows);
