project.HomeController = function()
{
    this.key_controller = new gtv.jq.KeyController();

    var latest_episodes_key_mapping = {};

    latest_episodes_key_mapping[project.keycodes.KEY_LEFT] = function(selectedItem, newSelected)
    {
        if (!selectedItem.is(jQuery('.latest_episodes .js_item_row').find('.js_item').first()))
        {
            newSelected = jQuery('.featured_shows .js_item_row').find('.js_item').last();
        }
        return new gtv.jq.Selection('selected', newSelected);
    };
    latest_episodes_key_mapping[project.keycodes.KEY_UP] = function(selectedItem, newSelected)
    {
        if (selectedItem.is(jQuery('.latest_episodes .js_item_row').find('.js_item').first()))
        {
            newSelected = jQuery('#nav').find('.js_item').last();
        }
        return new gtv.jq.Selection('selected', newSelected);
    };

    var shows_key_mapping = {};

    shows_key_mapping[project.keycodes.KEY_RIGHT] = function(selectedItem, newSelected)
    {
        if (selectedItem.is(jQuery('.featured_shows .js_item_row').find('.js_item').last()))
        {
            newSelected = jQuery('.latest_episodes .js_item_row').find('.js_item').last();
        }
        return new gtv.jq.Selection('selected', newSelected);
    };
    shows_key_mapping[project.keycodes.KEY_DOWN] = function(selectedItem, newSelected)
    {
        return new gtv.jq.Selection('skip');
    };

    var live_key_mapping = {};

    live_key_mapping[project.keycodes.KEY_UP] = function(selectedItem, newSelected)
    {
        newSelected = jQuery('#nav').find('.js_item').first();
        return new gtv.jq.Selection('selected', newSelected);
    };
    live_key_mapping[project.keycodes.KEY_RIGHT] = function(selectedItem, newSelected)
    {
        newSelected = jQuery('.latest_episodes .js_item').first();
        return new gtv.jq.Selection('selected', newSelected);
    };

    var shows_actions = {
        scrollIntoView: function(selectedItem, newItem, getFinishCallback)
        {
            var img = newItem.find('.js_fs_image');
            if (img.length > 0)
            {
                newItem.parent().addClass('active');
                img.attr({
                    'width': 80,
                    'height': 110
                });
            }
            
            if (selectedItem && (selectedItem.length > 0)  && (img = selectedItem.find('.js_fs_image')) && (img.length > 0))
            {
                selectedItem.parent().removeClass('active');
                img.attr({
                    'width': 70,
                    'height': 96
                });
            }
        },
        leaveZone: function(selectedItem)
        {
            var img;
            if (selectedItem && (selectedItem.length > 0) && (img = selectedItem.find('.js_fs_image')) && (img.length > 0))
            {
                selectedItem.parent().removeClass('active');
                img.attr({
                    'width': 70,
                    'height': 96
                });
            }
        }
    };

    var nav_zone = project.getMenuBehaviourZone();
    var live_zone = project.getDefaultBehaviourZone('.home .live_teaser', live_key_mapping);
    var shows_zone = project.getDefaultBehaviourZone('.home .featured_shows', shows_key_mapping, shows_actions);
    var episodes_zone = project.getDefaultBehaviourZone('.home .latest_episodes', latest_episodes_key_mapping);

    this.key_controller.addBehaviorZone(nav_zone);
    this.key_controller.addBehaviorZone(live_zone);
    this.key_controller.addBehaviorZone(shows_zone);
    this.key_controller.addBehaviorZone(episodes_zone);

    this.key_controller.start(nav_zone, true);
};

jQuery(document).ready(function()
{
   project.home_controller = new project.HomeController();
});
