project.LatestEpisodes = function(dom_element, options)
{
    this.dom_element = dom_element;

    this.episodes_list_element = this.dom_element.find('ul');

    this.logging_prefix = 'LatestEpisodes';

    var that = this;

    project.data_provider.callWebApi("latest_episodes&from=1&size=3", function(data)
    {
        if (!data.episodes || !(data.episodes.length > 0))
        {
            return;
        }

        var list_childs = that.episodes_list_element.children('li');
        jQuery.each(data.episodes, function(idx, episode)
        {
            if (idx > 2) // we only display the 3 latest episodes
            {
                return ;
            }

            var li_ele = jQuery(list_childs[idx]);
            li_ele.find('.js_le_image').attr({
                'src': encodeURI(episode.image_url),
                'alt': episode.title
            });

            li_ele.find('.js_item').attr('href', 'episode_detail.html?episodeid='+episode.id);

            li_ele.find('.js_le_headline').html(project.string_toolkit.createCleanExcerpt(episode.show_title, 17));
            li_ele.find('.js_le_subheadline').html(episode.episode_number + ': ' + project.string_toolkit.createCleanExcerpt(episode.title, 15));
            li_ele.find('.js_le_description').html(project.string_toolkit.createCleanExcerpt(episode.text, 40));
        });

        that.dom_element.removeClass('hide');
    });

    // Webtrends Tracking for Home
    project.track('Home', 'Home', 'Home');
};

jQuery.extend(true, project.LatestEpisodes.prototype, new project.Log());

JsBehaviourToolkit.registerHandler('latest_episodes', project.LatestEpisodes);
