/*
 * If no console is defined, let's replace the console with empty functions! 
 */
if (typeof(console) === "undefined")
{
    var empty_function = function()
    {
    };

    console = {};
    console.log = empty_function;
    console.error = empty_function;
    console.info = empty_function;
    console.debug = empty_function;
    console.trace = empty_function;
}
else 
{
    if (typeof console.log === 'object')
    {
        // IE hacks :(
        console.trace = function()
        {
            console.log(arguments);
        };
    }
    else
    {
        console.trace = function()
        {
            console.log.apply(this, arguments);
        };
    }
}

project.Log = function(prefix)
{
    this.logging_prefix = prefix || 'NO_PREFIX_SET';
    
};

project.Log.prototype = { 

    setLoggingPrefix: function(prefix)
    {
        this.logging_prefix = prefix || 'EMPTY_PREFIX';
    },

    logWithPrefix: function(log_type, args)
    {
        if (project.enable_log)
        {
            var args_two = Array.prototype.slice.apply(args);
            args_two.unshift("[" + this.logging_prefix + "]");
            console[log_type].apply(console, args_two);

            if (project.debug)
            {
                project.trace(args_two);
            }

            if (project.samsung)
            {
                alert(args_two);
            }
        }
    },

    trace: function()
    {
        this.logWithPrefix('trace', arguments);
    },

    debug: function()
    {
        this.logWithPrefix('log', arguments);
    },

    info: function()
    {
        this.logWithPrefix('info', arguments);
    },

    warn: function()
    {
        this.logWithPrefix('info', arguments);
    },

    error: function()
    {
        this.logWithPrefix('error', arguments);
    }
};

