
project.Search = function(dom_element, options)
{
    var that = this;

    this.dom_element = dom_element;

    this.logging_prefix = 'Search';

    this.month_names = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];

    this.options = options || {};
    this.options.max_items = 4;

    this.active_page = 'shows';

    this.trace(arguments);

    this.search_results = {
        'shows': {
            'items': []
        },
        'episodes': {
            'items': []
        }
    };

    this.keyboard_input = this.dom_element.find('.lg_vk_horTextArea');
    this.search_input = this.dom_element.find('.js_search_input');
    this.search_form = this.dom_element.find('.js_search_form');
    this.search_submit = this.dom_element.find('.js_search_submit');

    this.shows_element = this.dom_element.find('.js_shows_list');
    this.episodes_element = this.dom_element.find('.js_episodes_list');

    var subnav_element = this.dom_element.find('.subnav');

    this.btn_episodes = subnav_element.find('.js_btn_episodes');
    this.btn_shows = subnav_element.find('.js_btn_shows');

    this.btn_episodes_count = this.btn_episodes.find('.js_episodes_count');
    this.btn_shows_count = this.btn_shows.find('.js_shows_count');

    this.pager_shows = this.dom_element.find('.js_pager_shows');
    this.pager_episodes = this.dom_element.find('.js_pager_episodes');
    
    
    this.requesting = false;

    this.btn_shows.parent().hide();
    this.btn_episodes.parent().hide();

    this.search_form.submit(function(e)
    {
        e.preventDefault();
    });

    this.search_submit.click(function(e)
    {
        e.preventDefault();
        that.showSearchResults(that.search_input.val());
    });

    this.search_input.keyup(function(event)
    {
        if (event.keyCode == 13 || event.keyCode == 404)
        {
            that.showSearchResults(that.search_input.val());
        }
    });

    this.keyboard_input.change(function(event)
    {
        alert('was getippt');
        
        if (event.keyCode == 13 || event.keyCode == 404)
        {
            that.showSearchResults(that.search_input.val());
        }
    });

    this.btn_shows.click(function()
    {
        that.active_page = 'shows';

        that.btn_shows.parent().addClass('active');
        that.btn_shows.removeClass('js_item');
        that.btn_episodes.parent().removeClass('active');
        that.btn_episodes.addClass('js_item');

        that.episodes_element.hide();
        that.shows_element.show();
        
        that.pager_shows.show();
        that.pager_episodes.hide();
    });

    this.btn_episodes.click(function()
    {
        that.active_page = 'episodes';

        that.btn_episodes.parent().addClass('active');
        that.btn_episodes.removeClass('js_item');
        that.btn_shows.parent().removeClass('active');
        that.btn_shows.addClass('js_item');

        that.episodes_element.show();
        that.shows_element.hide();

        that.pager_episodes.show();
        that.pager_shows.hide();
    });
    
    this.key_controller = new gtv.jq.KeyController();
    
    var nav_key_mapping = {
            13: function(selectedItem, newSelected)
            {
                project.navigateTo(selectedItem.attr('href'));
                return new gtv.jq.Selection('none');
            },
            37: function(selectedItem, newSelected) {
                //console.log('37 left', selectedItem, newSelected);
                if(selectedItem.is(jQuery('#nav').find('.js_item').first()))
                {
                    newSelected = jQuery('#nav').find('.js_item').last();
                }
                return new gtv.jq.Selection('selected', newSelected);
            },
            38: function(selectedItem, newSelected)
            {
                return new gtv.jq.Selection('skip');
            },
            39: function(selectedItem, newSelected) {
                //console.log('39 right', selectedItem, newSelected);
                if(selectedItem.is(jQuery('#nav').find('.js_item').last()))
                {
                    newSelected = jQuery('#nav').find('.js_item').first();
                }
                return new gtv.jq.Selection('selected', newSelected);
            },
            40: function(selectedItem, newSelected)
            {
                newSelected = jQuery('#search .js_item').first();
                return new gtv.jq.Selection('selected', newSelected);
            }
        };
        
        var search_key_mapping = {
                13: function(selectedItem, newSelected)
                {
                    selectedItem.click();
                    
                    newSelected = jQuery('.' + that.active_page + '_list .js_item').first();
                    if(newSelected.length)
                    {
                        return new gtv.jq.Selection('selected', newSelected);
                    }
                    
                    return new gtv.jq.Selection('none');
                },
                37: function(selectedItem, newSelected)
                {
                    return new gtv.jq.Selection('none');
                },
                38: function(selectedItem, newSelected)
                {
                    newSelected = jQuery('#nav .js_item').first();
                    return new gtv.jq.Selection('selected', newSelected);
                },
                39: function(selectedItem, newSelected)
                {
                    return new gtv.jq.Selection('none');
                },
                40: function(selectedItem, newSelected)
                {
                    newSelected = jQuery('.' + that.active_page + '_list .js_item').first();
                    return new gtv.jq.Selection('selected', newSelected);
                }
        };
    
        var subnav_key_mapping = {
            13: function(selectedItem, newSelected)
            {
                console.log('enter', selectedItem, newSelected);
                selectedItem.click();
                newSelected = jQuery('.' + that.active_page + '_list .js_item').first();
                if(newSelected.length)
                {
                    return new gtv.jq.Selection('selected', newSelected);
                }
                
                return new gtv.jq.Selection('none');
            },
            37: function(selectedItem, newSelected)
            {
                if(selectedItem.is(jQuery('.subnav .js_item').first()))
                {
                    newSelected = jQuery('.subnav .js_item').last();
                }
                return new gtv.jq.Selection('selected', newSelected);
            },
            38: function(selectedItem, newSelected)
            {
                console.log('up', selectedItem, newSelected);
                newSelected = jQuery('#nav .js_item').last();
                return new gtv.jq.Selection('selected', newSelected);
            },
            39: function(selectedItem, newSelected)
            {
                if(selectedItem.is(jQuery('.subnav .js_item').last()))
                {
                    newSelected = jQuery('.subnav .js_item').first();
                }
                return new gtv.jq.Selection('selected', newSelected);
            },
            40: function(selectedItem, newSelected)
            {
                newSelected = jQuery('.' + that.active_page + '_list .js_item').last();
                if(newSelected.length)
                {
                    return new gtv.jq.Selection('selected', newSelected);
                }
                else
                {
                    return new gtv.jq.Selection('skip');
                }
            }
        };

        var shows_key_mapping = {
            13: function(selectedItem, newSelected)
            {
                console.log('enter', selectedItem, newSelected);
                selectedItem.click();
                return new gtv.jq.Selection('none');
            },
            37: function(selectedItem, newSelected)
            {
                console.log('left', selectedItem, newSelected);
                if(selectedItem.is(jQuery('.' + that.active_page + '_list .js_item').first()))
                {
                    newSelected = jQuery('.' + that.active_page + '_list .js_item').last();
                }
                return new gtv.jq.Selection('selected', newSelected);
            },
            38: function(selectedItem, newSelected)
            {
                console.log('up', selectedItem, newSelected);
                if(selectedItem.is(jQuery('.' + that.active_page + '_list .js_item').last()) || selectedItem.is(jQuery('.' + that.active_page + '_list .js_item')[2]))
                {
                    newSelected = jQuery('.subnav .js_item').last();
                }           
                else
                {
                    newSelected = jQuery('#search .js_item').first();
                }
                
                return new gtv.jq.Selection('selected', newSelected);
            },
            39: function(selectedItem, newSelected)
            {
                console.log('right', selectedItem, newSelected);
                if(selectedItem.is(jQuery('.' + that.active_page + '_list .js_item').last()))
                {
                    newSelected = jQuery('.' + that.active_page + '_list .js_item').first();
                }
                return new gtv.jq.Selection('selected', newSelected);
            },
            40: function(selectedItem, newSelected)
            {
                console.log('down', selectedItem, newSelected);
                return new gtv.jq.Selection('none');
            }
        };
        var pager_key_mapping = {
                13: function(selectedItem, newSelected)
                {
                    console.log('enter', selectedItem, newSelected);
                    selectedItem.click();
                    return new gtv.jq.Selection('none');
                },
                37: function(selectedItem, newSelected)
                {
                    console.log('left', selectedItem, newSelected);
                    if(selectedItem.is(selectedItem.parent().parent().find('.js_item').first()))
                    {
                        newSelected = selectedItem.parent().parent().find('.js_item').last();
                    }
                    return new gtv.jq.Selection('selected', newSelected);
                },
                38: function(selectedItem, newSelected)
                {
                    console.log('up', selectedItem, newSelected);
                    
                    newSelected = jQuery('.' + that.active_page + '_list .js_item').last();
                    return new gtv.jq.Selection('selected', newSelected);
                },
                39: function(selectedItem, newSelected)
                {
                    console.log('right', selectedItem, newSelected);
                    if(selectedItem.is(selectedItem.parent().parent().find('.js_item').last()))
                    {
                        newSelected = selectedItem.parent().parent().find('.js_item').first();
                    }
                    return new gtv.jq.Selection('selected', newSelected);
                },
                40: function(selectedItem, newSelected)
                {
                    console.log('down', selectedItem, newSelected);
                    return new gtv.jq.Selection('skip');
                }
        };
        var navSelectors = {
            item: '.js_item',
            itemParent: '.js_item_parent',
            itemRow: '.js_item_row'
        };
        var selectionClasses = {
            basic: 'selected'
        };
        var actions = {
            scrollIntoView: function(selectedItem, newItem, getFinishCallback)
            {
                console.log('scrollIntoView', selectedItem, newItem);
            }
        };

        this.nav_zone = new gtv.jq.KeyBehaviorZone({
            containerSelector: '#nav',
            keyMapping: nav_key_mapping,
            actions: actions,
            navSelectors: navSelectors,
            selectionClasses: selectionClasses,
            useGeometry: true
        });
        this.search_zone = new gtv.jq.KeyBehaviorZone({
            containerSelector: '#search',
            keyMapping: search_key_mapping,
            actions: actions,
            navSelectors: navSelectors,
            selectionClasses: selectionClasses,
            useGeometry: true
        });
        this.subnav_zone = new gtv.jq.KeyBehaviorZone({
            containerSelector: '.subnav',
            keyMapping: subnav_key_mapping,
            actions: actions,
            navSelectors: navSelectors,
            selectionClasses: selectionClasses,
            useGeometry: true
        });
        this.shows_zone = new gtv.jq.KeyBehaviorZone({
            containerSelector: '.list_container',
            keyMapping: shows_key_mapping,
            actions: actions,
            navSelectors: navSelectors,
            selectionClasses: selectionClasses,
            useGeometry: true
        });
        this.pager_shows_zone = new gtv.jq.KeyBehaviorZone({
            containerSelector: '.js_pager_shows',
            keyMapping: pager_key_mapping,
            actions: actions,
            navSelectors: navSelectors,
            selectionClasses: selectionClasses,
            useGeometry: false
        });            
        this.pager_episodes_zone = new gtv.jq.KeyBehaviorZone({
            containerSelector: '.js_pager_episodes',
            keyMapping: pager_key_mapping,
            actions: actions,
            navSelectors: navSelectors,
            selectionClasses: selectionClasses,
            useGeometry: false
        });            

        this.key_controller.addBehaviorZone(this.nav_zone, true);
        this.key_controller.addBehaviorZone(this.search_zone, false);    
        this.key_controller.addBehaviorZone(this.subnav_zone, false);
        this.key_controller.addBehaviorZone(this.shows_zone, false);
        this.key_controller.addBehaviorZone(this.pager_shows_zone, false);
        this.key_controller.addBehaviorZone(this.pager_episodes_zone, false);

        this.key_controller.start(this.nav_zone, true);
};

project.Search.prototype = {

    showSearchResults: function(search_term)
    {
        this.trace('showSearchResults', arguments);
        var that = this;

        if (this.requesting)
        {
            return ;
        }

        this.requesting = true;

        this.shows_element.empty();
        this.episodes_element.empty();

        project.data_provider.callWebApi("search&q=" + search_term, function(data)
        {
            that.trace('API call for search completed: ', data);

            that.search_results['shows'].items = data.shows;
            that.search_results['episodes'].items = data.episodes;

            that.btn_shows_count.text(data.shows.length);
            that.btn_episodes_count.text(data.episodes.length);

            that.btn_shows.parent().show();
            that.btn_episodes.parent().show();

            that.requesting = false;

            new project.Pager(that.pager_shows, that.options.max_items, data.shows.length, function(from)
            {
                that.buildShowList(from - 1);
                that.key_controller.addBehaviorZone(that.pager_zone, false);
            });

            new project.Pager(that.pager_episodes, that.options.max_items, data.episodes.length, function(from)
            {
                that.buildEpisodeList(from - 1);
                that.key_controller.addBehaviorZone(that.pager_zone, false);
            });

            that.buildShowList(0);
            that.buildEpisodeList(0);

            that.btn_shows.click();
        });
    },

    buildShowList: function(index)
    {
        var that = this;

        this.trace('buildShowList', arguments);
        
        this.shows_element.empty();

        last_index = index + that.options.max_items - 1;
        
        for (var i = index; i <= last_index; i++)
        {
            var show = that.search_results['shows'].items[i];

            if (typeof(show) != 'undefined')
            {
                (function(i, show)
                {
                    project.template_registry.retrieveTemplate('search/shows_item', function(html, options)
                    {
                        html.find('.js_sr_image').attr({
                            'src': show.thumbnail_url,
                            'alt': show.title
                        });
        
                        html.find('.js_sr_title').text(show.title);
        
                        var description = project.shortenString(show.description, 100);
                        html.find('.js_sr_desc').text(description);

                        html.find('.js_sr_link').click(function(e)
                        {
                            e.preventDefault();
                            project.navigateTo('episodes.php?showid=' + show.id);
                        });

                        if (i == last_index)
                        {
                            html.addClass('last');
                        }
        
                        that.shows_element.append(html);
                    });
                })(i, show);
            }
        }
    },

    buildEpisodeList: function(index)
    {
        var that = this;
        
        this.trace('buildEpisodeList', arguments);
        
        this.episodes_element.empty();
        
        last_index = index + that.options.max_items - 1;
        
        for (var i = index; i <= last_index; i++)
        {
            var episode = that.search_results['episodes'].items[i];

            if (typeof(episode) != 'undefined')
            {
                (function(i, episode)
                {
                    project.template_registry.retrieveTemplate('search/episodes_item', function(html, options)
                    {
                        html.find('.js_sr_image').attr({
                            'src': episode.image_url,
                            'alt': episode.title
                        });

                        html.find('.js_sr_title').text(episode.title);

                        var description = project.shortenString(episode.text, 100);
                        html.find('.js_sr_desc').text(description);

                        var on_air_date = episode.airdate;
                        on_air_date = Date.parse(on_air_date);
                        on_air_date = new Date(on_air_date);
                        on_air_date = that.month_names[on_air_date.getMonth()] + ' ' + on_air_date.getDate() + ', ' + on_air_date.getFullYear();
                        html.find('.js_sr_date').text(on_air_date);
                        
                        //html.find('.js_sr_date').text(episode.);

                        console.log(episode);

                        html.find('.js_sr_link').click(function(e)
                        {
                            e.preventDefault();
                            project.navigateTo('episode_detail.php?episodeid=' + episode.id);
                        });

                        if (i == last_index)
                        {
                            html.addClass('last');
                        }

                        that.episodes_element.append(html);
                    });
                })(i, episode);
            }
        }
    }
};

jQuery.extend(true, project.Search.prototype, new project.Log());

JsBehaviourToolkit.registerHandler('search', project.Search);
