project = {};

project.api_url = 'http://www.redbull.tv/cs/Satellite?pagename=RBWebTV/RBWTVAPI&command=';
project.livestream_url = 'http://live.iphone.redbull.de.edgesuite.net/webtvHD.m3u8|COMPONENT=HLS';
project.tracking_device = 'Samsung';

project.enable_log = true;

/*
 * get samsung specific api
 */
if (typeof Common != 'undefined')
{
    project.samsung = true;
    project.enable_log = false;
    project.keycodes = new Common.API.TVKeyValue();
}
else
{
    /*
     * fallback for real browsers
     */
    project.keycodes = {
        KEY_ENTER: 13,
        KEY_RETURN: 8,
        KEY_EXIT: 0,
        KEY_SOURCE: 0,
        KEY_PANEL_MENU: 0,
        KEY_RIGHT: 39,
        KEY_LEFT: 37,
        KEY_UP: 38,
        KEY_DOWN: 40,
        KEY_PLAY: 80, //p
        KEY_STOP: 83, //s
        KEY_PAUSE: 80, //p
        KEY_PANEL_VOL_UP: 0,
        KEY_PANEL_VOL_DOWN: 0,
        KEY_VOL_UP: 0,
        KEY_VOL_DOWN: 0
    };
}

jQuery(window).keydown(function(e)
{
    if (e.keyCode == project.keycodes.KEY_RETURN || e.keyCode == project.keycodes.KEY_PANEL_RETURN)
    {
        if (project.player && project.player.fullscreen)
        {
            e.preventDefault();
        }
        else if (jQuery('body.home').length === 0)
        {
            e.preventDefault();
            history.back();
        }
    }
    else if (e.keyCode == 116) // F5
    {
        var widget_api = new Common.API.Widget();
        widget_api.sendReturnEvent();
    }
});

jQuery(window).unload(function(e)
{
    /*
     * stop player to avoid crashes
     */
    var video = document.getElementById("video");

    if (video)
    {
        video.Stop();
    }
});

/*
 * debug window
 */
project.debug = false;

if (project.debug)
{
    jQuery(document).ready(function()
    {
        var styles = 'position:absolute;top:80px;left:100px;width:500px;height:450px;overflow:auto;background:#fff;border: 1px solid green;font-size:14px;color: black;z-index:9999;';

        jQuery('body').prepend(jQuery('<div id="debug" style="' + styles + '"><div class="js_console">' + navigator.userAgent + '</div></div>'));
    });

    window.addEventListener('keydown', function(e)
    {
        project.trace('keydown: '+ e.keyCode);
    }, false);

}

project.trace = function(msg)
{
    if (project.debug)
    {
        jQuery('#debug .js_console').prepend(msg + "<br/>");
    }
};

/*
 * basic functions
 */
project.getScriptBase = function()
{
    var href = document.location.href;
    return href.replace(/\\/g,'/').replace(/\/[^\/]*$/, '')  + '/';
};

project.navigateTo = function(path)
{
    /*
     * stop player to avoid crashes
     */
    var video = document.getElementById("video");

    if (video)
    {
        video.Stop();
    }

    document.location = project.getScriptBase() + path;
};

/*
 * default navigations
 */
project.default_key_mapping = {};

project.default_key_mapping[project.keycodes.KEY_ENTER] = function(selectedItem, newSelected)
{
    project.navigateTo(selectedItem.attr('href'));
    return new gtv.jq.Selection('none');
};

project.getDefaultBehaviourZone = function(selector, key_mapping, actions)
{
    key_mapping = jQuery.extend({}, project.default_key_mapping, key_mapping);

    actions = actions || {};

    return new gtv.jq.KeyBehaviorZone({
        containerSelector: selector,
        keyMapping: key_mapping,
        actions: actions,
        navSelectors: {
            item: '.js_item',
            itemParent: '.js_item_parent',
            itemRow: '.js_item_row'
        },
        selectionClasses: { 
            basic: 'selected' 
        },
        saveRowPosition: true,
        selectHidden: false,
        useGeometry: true
    });
};

project.getMenuBehaviourZone = function(key_mapping)
{
    var default_key_mapping = {};
    
    default_key_mapping[project.keycodes.KEY_LEFT] = function(selectedItem, newSelected)
    {
        if (selectedItem.is(jQuery('#nav').find('.js_item').first()))
        {
            newSelected = jQuery('#nav').find('.js_item').last();
        }
        return new gtv.jq.Selection('selected', newSelected);
    };
    
    default_key_mapping[project.keycodes.KEY_RIGHT] = function(selectedItem, newSelected)
    {
        if (selectedItem.is(jQuery('#nav').find('.js_item').last()))
        {
            newSelected = jQuery('#nav').find('.js_item').first();
        }
        return new gtv.jq.Selection('selected', newSelected);
    };
    
    default_key_mapping[project.keycodes.KEY_DOWN] = function(selectedItem, newSelected)
    {
        newSelected = jQuery('#subnav .js_item').first();
        return new gtv.jq.Selection('selected', newSelected);
    };
    
    key_mapping = jQuery.extend({}, default_key_mapping, key_mapping);
    
    return project.getDefaultBehaviourZone('#nav', key_mapping);
};

project.getSubMenuBehaviourZone = function(key_mapping)
{
    var default_key_mapping = {};

    default_key_mapping[project.keycodes.KEY_LEFT] = function(selectedItem, newSelected)
    {
        if (selectedItem.is(jQuery('.subnav .js_item').first()))
        {
            newSelected = jQuery('.subnav .js_item').last();
        }
        return new gtv.jq.Selection('selected', newSelected);
    };
    default_key_mapping[project.keycodes.KEY_UP] = function(selectedItem, newSelected)
    {
        newSelected = jQuery('#nav .js_item').last();
        return new gtv.jq.Selection('selected', newSelected);
    };
    default_key_mapping[project.keycodes.KEY_RIGHT] = function(selectedItem, newSelected)
    {
        if (selectedItem.is(jQuery('.subnav .js_item').last()))
        {
            newSelected = jQuery('.subnav .js_item').first();
        }
        return new gtv.jq.Selection('selected', newSelected);
    };

    key_mapping = jQuery.extend({}, default_key_mapping, key_mapping);

    return project.getDefaultBehaviourZone('.subnav', key_mapping);
};

project.getPagerBehaviourZone = function(key_mapping)
{
    var default_key_mapping = {};

    default_key_mapping[project.keycodes.KEY_LEFT] = function(selectedItem, newSelected)
    {
        if (selectedItem.is(jQuery('.pager').find('.js_item').first()))
        {
            newSelected = jQuery('.pager').find('.js_item').last();
        }
        return new gtv.jq.Selection('selected', newSelected);
    };
    default_key_mapping[project.keycodes.KEY_UP] = function(selectedItem, newSelected)
    {
        newSelected = jQuery('.subnav .js_item').first();
        return new gtv.jq.Selection('selected', newSelected);
    };
    default_key_mapping[project.keycodes.KEY_RIGHT] = function(selectedItem, newSelected)
    {
        if (selectedItem.is(jQuery('.pager').find('.js_item').last()))
        {
            newSelected = jQuery('.pager').find('.js_item').first();
        }
        return new gtv.jq.Selection('selected', newSelected);
    };
    default_key_mapping[project.keycodes.KEY_DOWN] = function(selectedItem, newSelected)
    {
        return new gtv.jq.Selection('selected', jQuery('#nav .js_item').first());
    };

    key_mapping = jQuery.extend({}, default_key_mapping, key_mapping);

    return project.getDefaultBehaviourZone('.pager', key_mapping);
};

/*
 * Webtrends Tracking
 */
project.track = function(title, section, subsection1, subsection2, subsection3)
{
    var url = "http://statse.webtrendslive.com/dcsks8fcpuz5bdjvask4evtqq_6x5y/njs.gif?";
    var dcsuri = project.tracking_device + "/" + section + "/" + subsection1;

    url += "WT.z_iTV=true&WT.z_external=true&WT.js=No"
    url += "&WT.z_device=" + project.tracking_device;
    url += "&WT.dcssip=" + escape(title);
    url += "&WT.ti=" + escape(title);
    url += "&WT.cg_n=" + escape(section);
    url += "&WT.cg_s=" + escape(subsection1);

    if (subsection2)
    {
        url += "&WT.z_cg_3=" + escape(subsection2);
        dcsuri += "/" + subsection2;

        if (subsection3)
        {
            url += "&WT.z_cg_4=" + escape(subsection3);
            dcsuri += "/" + subsection3;
        }
    }

    url += "&dcsuri=/" + escape(dcsuri);

    jQuery('#webtrends_tracking').remove();
    jQuery('body').append(jQuery('<img class="hideme" id="webtrends_tracking" src="' + url + '" alt="" />'));
};